Subject: RFC2119 Keywords

From: "David Fischer" <[email-masked]>
Date: Fri, 15 Feb 2002 00:54:07 -0600

I am working in a standards group and a disagreement has
arisen concerning RFC2119.

Is the 2119 keyword simply "must" or "MUST" or "Must" or
"MuSt" ... , or is the weight of the 2119 definition
reserved strictly for "MUST" (all caps)?  I assume the
answer would equally apply to the entire list of 2119
keywords.

Regards,

David Fischer
Drummond Group.

---

From: [email-masked]
Date: Fri, 15 Feb 2002 02:39:43 -0500

> arisen concerning RFC2119.

You have my condolences. ;)

> answer would equally apply to the entire list of 2119

From RFC3211 (which uses the same boilerplate as most post-2119 RFCs):

   The key words "MUST", "MUST NOT", "REQUIRED", "SHOULD", "SHOULD NOT",
   "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be
   interpreted as described in RFC 2119.

So I'd say "if you mean the 2119 meaning, use ALL CAPS".
-- 
				Valdis Kletnieks
				Computer Systems Senior Engineer
				Virginia Tech

---

From: Robert Elz <[email-masked]>
Date: Fri, 15 Feb 2002 15:34:28 +0700

Date:        Fri, 15 Feb 2002 00:54:07 -0600
    From:        "David Fischer" <[email-masked]>
    Message-ID:  <[email-masked]>

  | Is the 2119 keyword simply "must" or "MUST" or "Must" or
  | "MuSt" ... , or is the weight of the 2119 definition
  | reserved strictly for "MUST" (all caps)?  I assume the
  | answer would equally apply to the entire list of 2119
  | keywords.

All caps MUST be used for 2119 to apply - unless your doc says
otherwise - it could of course, it could say
	we treat "must" as if it was MUST from bcp14
instead of just saying that 2119 is used (if you don't mention
2119 at all, you'll just have a somewhat strange typographical convention,
which will probably result in the IESG getting annoyed with you).

And yes, all of them.

kre

---

From: [email-masked]
Date: Fri, 15 Feb 2002 13:01:20 +0100 (MET)

> answer would equally apply to the entire list of 2119

If the 2119 keywords included the any caps versions, eg "must" and "Must"
and...etc, you'd have to avoid using those keywords in your english to not
invoke the definitions in rfc2119 everywhere. If it is limited to
the all caps versions, eg "MUST", things get a bit easier. I don't think
the author of 2119 intended for everyone to watch their language.

Ketil

---

From: Scott Brim <[email-masked]>
Date: Fri, 15 Feb 2002 08:15:40 -0500

> the author of 2119 intended for everyone to watch their language.

In normative text, I don't see how "must" could occur anywhere except
where it was supposed to mean "MUST".  I use all-caps but I think we're
more experienced these days and we could stop shouting at each other now
if we chose to.

---

From: Harald Tveit Alvestrand <[email-masked]>
Date: Fri, 15 Feb 2002 06:04:55 -0800

standard usage has been that one MUST write MUST in all upper case to get 
the magical meaning.

The reason MUST be that MUSTy old grammarians MAY think that one SHOULD not 
attach special meanings to words just because they MAY occur in places 
where they MUST occur in order to make the meaning apparent to a normal 
reader of English.

This is most apparent in the month of May.

                Harald

--On 15. februar 2002 00:54 -0600 David Fischer <[email-masked]> 
wrote:

>
> I am working in a standards group and a disagreement has arisen
> concerning RFC2119.
> Is the 2119 keyword simply "must" or "MUST" or "Must" or "MuSt" ... , or
> is the weight of the 2119 definition reserved strictly for "MUST" (all
> caps)?  I assume the answer would equally apply to the entire list of
> 2119 keywords.
> Regards,
>
> David Fischer
> Drummond Group.

---

From: [email-masked]
Date: Fri, 15 Feb 2002 09:16:58 -0500

> more experienced these days and we could stop shouting at each other now

We thrashed this out a few weeks ago, and decided we SHOULD NOT issue
sidearms to the Protocol Police.  Therefor, shouting MUST be supported,
since we are still supporting flat-ASCII format for RFCs, and as a
result, there is no way to attach a Krushchev-style banging-of-shoes
to a "you MUST NOT do this" requirement....

Or maybe I'm just astounded that we live in a world where there exist deployed
MUAs that don't understand the distinction between a CRLF and an unquoted CR in
a RFC822 header, and I really should get some more caffeine before hitting
the 'send' button... ;)
--

				Valdis Kletnieks

---

From: Keith Moore <[email-masked]>
Date: Fri, 15 Feb 2002 09:53:38 -0500

> where it was supposed to mean "MUST". 

Perhaps, but often we don't clearly distinguish between normative
and non-normative text.  Using the 2119 keywords (spelled in all
capitals) helps us do that.

I've certainly seen cases in standards documents where it was useful
to distinguish "should" from "SHOULD".  "SHOULD" imposes a (conditional) 
requirement on implementations, while "should" can be used for advisory 
text.

I don't believe the intent of 2119 was to change the meanings of
"should", "must", etc., in RFCs, but rather to define new terms 
"SHOULD", "MUST", etc., with specific new meanings.

Keith

---

From: "Kurt D. Zeilenga" <[email-masked]>
Date: Fri, 15 Feb 2002 07:42:26 -0800

>So I'd say "if you mean the 2119 meaning, use ALL CAPS".

I think the source of confusing is the statement "These words
are often capitalized" in RFC 2119.  This implies that the words
have the same meaning when NOT capitalized.

Kurt

---

From: Jian Bo Huang <[email-masked]>
Date: Fri, 15 Feb 2002 16:02:59 -0000

Dear Sirs,

For my project needs, I want know some statistic data on the usage of IP
address. That means:

1) How many addresses are occupied and how many are unassigned?
2) How many addresses are used for servers, routers and other network
equipments, in contrast with the user end PCs or workstations? That is
the ratio of end user workstations to network equipments.

I tried to find, but failed on no idea! Have you any suggestion?

Thank you!

Truly yours,
Jian Bo Huang

MSc Student
Department of Electronic Engineering,
University of Surrey
Guildford, Surrey
GU2 7XH, UK
Email: [email-masked]
	  Or [email-masked]
Phone: +44-870-2820955

---

From: "Jose Manuel Arronte Garcia" <[email-masked]>
Date: Fri, 15 Feb 2002 10:34:11 -0600

Have you tried www.netsizer.com?
I'm not sure if it has the data you need, but at least may give you and
idea...

Saludos.
Regards.
____________________________________________________
José Manuel Arronte García
Supervisor de Soporte Técnico Helpdesk

Meg@Red Veracruz
Telecomunicaciones y Entretenimiento S. A. de C. V.
Av. S. Díaz Mirón 2625-A
Fracc. Moderno 91916
Veracruz Ver. MÉXICO

+52 (229) 923-0400, 923-0410 ext. 5
http://www.megacable.com.mx/
http://www.megared.net.mx/

____________________________________________________
"Who's the more foolish, the fool, or the fool who follows him?".
 --O. W. Kenobi (in Star Wars ep.IV: A New Hope)

---

From: Paul Hoffman / IMC <[email-masked]>
Date: Fri, 15 Feb 2002 09:10:07 -0800

>where it was supposed to mean "MUST".

It occurs when describing how something happened, not what needs to 
happen. Example from a current Internet Draft that is having the 
capitalization fixed:

...not less than 3, but 4 is less than 5, so 4 must be the last digit.
->
...not less than 3, but 4 is less than 5, so 4 has to be the last digit.

There were a few places where the "must" turned into a "MUST" as a 
way of specifying how an implementation of the protocol had to work.

--Paul Hoffman, Director
--Internet Mail Consortium

---

From: "RL 'Bob' Morgan" <[email-masked]>
Date: Fri, 15 Feb 2002 09:43:25 -0800 (PST)

> way of specifying how an implementation of the protocol had to work.

Yes.  The subject of the capitalized verb MUST (SHOULD, MAY, etc) is
always, at least implicitly, "an implementation of this specification".
Sentences about other things in specs often use {must|should|may|etc} in
the ordinary sense.

 - RL "Bob" (yes, I was an English major ...)

---

From: Robert Elz <[email-masked]>
Date: Tue, 19 Feb 2002 16:49:22 +0700

Date:        Fri, 15 Feb 2002 09:43:25 -0800 (PST)
    From:        "RL 'Bob' Morgan" <[email-masked]>
    Message-ID:  <[email-masked]>

  | Yes.  The subject of the capitalized verb MUST (SHOULD, MAY, etc) is
  | always, at least implicitly, "an implementation of this specification".

You'd think that should be the case, and given 2119 it is all that makes
sense, but there are way too many cases where the subject turns out to
be (explicitly or implicitly) "authors of future RFCs".

kre

---

From: "Larry Masinter" <[email-masked]>
Date: Sun, 24 Feb 2002 13:35:41 -0800

> be (explicitly or implicitly) "authors of future RFCs".

In RFC 2542 ("Terminology and Goals for Internet Fax") I wound up
using a notation {1} {2} {3} to replace MUST/SHOULD/MAY when talking
about what future RFCs should do

      {1} there is general agreement that this is a critical
          characteristic of any definition of ....
      {2} most believe that this is an important characteristic
          of .....
      {3} there is general belief that this is a useful feature
          of ....., but that other factors might override;
          a definition that does not provide this element is
          acceptable.